<template>
    <div id="app">
        <v-app>
            <!--put model drawer to navbar-->
            <nav-bar @click="drawer =!drawer"/>

            <v-container v-bind:class="{ 'px-0': $vuetify.breakpoint.smAndDown }">
                <transition mode="out-in" name="component-fade">
                    <router-view></router-view>
                </transition>
                <v-navigation-drawer
                        v-model="drawer"
                        absolute
                        temporary

                >
                    <v-list class="pa-1">
                        <v-list-tile avatar>
                            <!--account icon-->
                            <v-list-tile-avatar>
                                <i class="material-icons" style="font-size: 48px;color: #1A237E;">
                                    account_circle
                                </i>
                            </v-list-tile-avatar>

                            <!--info about logged in user-->
                            <v-list-tile-content class="mt-2">
                                <v-list-tile-title style="font-size: 18px;color: #1A237E;">{{ this.user.name }}
                                </v-list-tile-title>
                                <v-list-tile-sub-title>{{ this.user.email }}</v-list-tile-sub-title>
                                <v-list-tile-sub-title>Kasutaja on {{ this.translateRoles[this.user.role] }}</v-list-tile-sub-title>
                            </v-list-tile-content>

                        </v-list-tile>
                    </v-list>

                    <v-list class="pt-2" dense>
                        <v-divider></v-divider>

                        <!--show links-->
                        <v-list-tile
                                v-for="link in links"
                                :key="link.text"
                        >

                            <v-list-tile-content>
                                <v-btn color="primary" flat block :to='link.url'>{{ link.text }}</v-btn>
                            </v-list-tile-content>
                        </v-list-tile>

                        <v-divider></v-divider>

                        <!--logout-->
                        <v-list-tile @click="this.logout">

                            <v-list-tile-content>
                                <v-btn flat block color="white" class="indigo darken-4">Logi välja</v-btn>
                            </v-list-tile-content>

                        </v-list-tile>
                    </v-list>
                </v-navigation-drawer>
            </v-container>
        </v-app>
    </div>
</template>

<script>
    import NavBar from "../components/NavBar";
    import {mapGetters} from "vuex";

    export default {
        name: 'AppLayout',
        components: {
            NavBar
        },
        data() {
            return {
                links: [
                    {url: '/', text: 'Avaleht'},
                    // {url: '/calendar', text: 'Üritused'},
                    {url: '/votes', text: 'Hääletused'},
                    // {url: '/gallery', text: 'Galerii'},
                    {url: '/candidating', text: 'Kandideeri'},
                    {url: '/info', text: 'Info'},
                    {url: '/contact', text: 'Kontakt'},
                ],
                drawer: false,
                translateRoles: {
                    admin: 'administraator',
                    moderator: 'õpilasesinduse liige',
                    user: 'tavakasutaja',
                }
            }
        },
        methods: {
            //Log out and redirect to login page
            logout: function () {
                this.$store.dispatch('AUTH_LOGOUT')
                    .then(() => {
                        this.$router.push({name: 'login'})
                    })
            }
        },
        //Get logged in user info
        computed: {
            ...mapGetters([
                'user'
            ])
        }
    }
</script>
